Package picard.util.help

## Class PicardHelpDoclet

- java.lang.Object
- - org.broadinstitute.barclay.help.HelpDoclet
  - - picard.util.help.PicardHelpDoclet

-     public class PicardHelpDoclet
      extends org.broadinstitute.barclay.help.HelpDoclet

  Custom Barclay-based Javadoc Doclet used for generating Picard help/documentation. NOTE: Methods in this class are intended to be called by Gradle/Javadoc only, and should not be called by methods that are used by the Picard runtime. This class has a dependency on com.sun.javadoc classes, which may not be present since they're not provided as part of the normal Picard runtime classpath.

- - ### Field Summary

    - ### Fields inherited from class org.broadinstitute.barclay.help.HelpDoclet

      `absoluteVersion, buildTimestamp, destinationDir, indexFileExtension, isSettingsDirSet, logger, outputFileExtension, settingsDir, showHiddenFeatures, useDefaultTemplates, workUnits`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PicardHelpDoclet()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected org.broadinstitute.barclay.help.DocWorkUnit` | `createWorkUnit​(org.broadinstitute.barclay.help.DocumentedFeature documentedFeature, ClassDoc classDoc, Class<?> clazz)` |
    `protected Map<String,​String>` | `getGroupMap​(org.broadinstitute.barclay.help.DocWorkUnit docWorkUnit)` | Adds a super-category so that we can custom-order the categories in the doc index
    `String` | `getIndexTemplateName()` | Return the name of the freemarker template to be used for the index generated by Barclay.
    `static boolean` | `start​(RootDoc rootDoc)` | Create a doclet of the appropriate type and generate the FreeMarker templates properties.

    - ### Methods inherited from class org.broadinstitute.barclay.help.HelpDoclet

      `createGSONWorkUnit, findWorkUnitForClass, getBuildTimeStamp, getBuildVersion, getClassDocForClass, getDestinationDir, getIndexBaseFileName, getIndexFileExtension, getOutputFileExtension, getRootDoc, groupIndexMap, includeInDocs, indexDataMap, optionLength, parseOption, processIndexTemplate, processWorkUnitTemplate, showHiddenFeatures, startProcessDocs, validateDocletStartingState`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PicardHelpDoclet

          public PicardHelpDoclet()

  - ### Method Detail

    - #### start

          public static boolean start​(RootDoc rootDoc)
                               throws IOException

      Create a doclet of the appropriate type and generate the FreeMarker templates properties.
      Parameters:
        `rootDoc` -
      Throws:
        `IOException`

    - #### getIndexTemplateName

          public String getIndexTemplateName()

      Return the name of the freemarker template to be used for the index generated by Barclay. Must reside in the folder passed to the Barclay Javadc Doclet via the "-settings-dir" parameter.
      Overrides:
        `getIndexTemplateName` in class `org.broadinstitute.barclay.help.HelpDoclet`
      Returns:
        name of freemarker index template

    - #### createWorkUnit

          protected org.broadinstitute.barclay.help.DocWorkUnit createWorkUnit​(org.broadinstitute.barclay.help.DocumentedFeature documentedFeature,
                                                                               ClassDoc classDoc,
                                                                               Class<?> clazz)

      Overrides:
        `createWorkUnit` in class `org.broadinstitute.barclay.help.HelpDoclet`
      Parameters:
        `documentedFeature` - DocumentedFeature annotation for the target feature
        `classDoc` - javadoc classDoc for the target feature
        `clazz` - class of the target feature
      Returns:
        Create and return a DocWorkUnit-derived object to handle documentation for the target feature(s) represented by documentedFeature.

    - #### getGroupMap

          protected final Map<String,​String> getGroupMap​(org.broadinstitute.barclay.help.DocWorkUnit docWorkUnit)

      Adds a super-category so that we can custom-order the categories in the doc index
      Overrides:
        `getGroupMap` in class `org.broadinstitute.barclay.help.HelpDoclet`
      Parameters:
        `docWorkUnit` -
      Returns:
        root Map after having added the super-category